<template>
  <div class="the-configurator__scrollarea">
    <div class="flex items-center justify-between">
      <p class="text-txtdprim font-bold text-2xl leading-7 xs:text-lg xs:leading-6">{{ $t('configurator.title') }}</p>
      <UiButton button-height="sm" color-type="secondary" class="w-12 rounded-16" @click="closeButtonTheConfigurator">
        <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
      </UiButton>
    </div>
    <div class="mt-8 flex gap-2 items-center">
      <p class="text-txtdsec font-medium">{{ $t('configurator.chain') }}</p>
      <div>
        <img width="20" height="20" src="@/assets/images/ui/ui-info.svg" />
      </div>
    </div>
    <UiDropdown v-model="value.chain" :options="coins" class="mt-4" />
    <div class="grid grid-cols-2 xs:grid-cols-1 gap-8 xs:gap-4">
      <div>
        <div class="mt-8 flex gap-2 items-center">
          <p class="text-txtdsec font-medium">{{ $t('configurator.network') }}</p>
          <div>
            <img width="20" height="20" src="@/assets/images/ui/ui-info.svg" />
          </div>
        </div>
        <UiRange v-model="value.network" :values="networks" class="mt-4" @range-touch="handleRangeTouch" />
      </div>
      <div>
        <div class="mt-8 flex gap-2 items-center">
          <p class="text-txtdsec font-medium">{{ $t('configurator.mode') }}</p>
          <div>
            <img width="20" height="20" src="@/assets/images/ui/ui-info.svg" />
          </div>
        </div>
        <UiRange v-model="value.mode" translate :values="modes" class="mt-4" @range-touch="handleRangeTouch" />
      </div>
    </div>
    <div class="mt-8 xs:mt-4">
      <div class="flex items-center gap-2">
        <p class="font-medium text-txtdsec">{{ $t('configurator.period') }}</p>
        <p class="font-medium text-txtdtert">{{ form.period?.title }}</p>
      </div>
      <UiRange v-model="value.period" translate :values="periods" class="mt-4" @range-touch="handleRangeTouch" />
    </div>
    <UiButton button-height="md" color-type="primary" class="mt-12 xs:mt-8 rounded-24 gap-3" @click="handlePayClick">
      <img width="24" height="24" src="@/assets/images/ui/ui-usd.svg" />
      <p>{{ $t('configurator.pay') }}: ${{ value.total }}.<span style="opacity: 0.32">00</span></p>
    </UiButton>
  </div>
</template>

<script lang="ts">
import ProjectConfigurations from '@/mixins/ProjectConfigurations';
import UiDropdown from '@/components/ui/UiDropdown.vue';
import UiButton from '@/components/ui/UiButton.vue';
import UiRange from '@/components/ui/UiRange.vue';

export default {
  name: 'CreateEndpoint',

  components: { UiDropdown, UiButton, UiRange },

  mixins: [ProjectConfigurations],

  props: {
    form: {
      type: Object,
      default: () => ({}),
    },
  },

  data() {
    return {
      value: {
        chain: {
          title: 'Ethereum',
          key: 'ETH',
        },
        network: {
          title: 'Mainnet',
          key: 'mainnet',
        },
        mode: {
          title: 'Full',
          key: 'full',
        },
        period: {
          title: '3 days',
          key: '3d',
        },
        total: 50,
      },
    };
  },

  watch: {
    value: {
      deep: true,
      handler() {
        this.updateTotal();
        this.$emit('update-value', this.value);
      },
    },
  },

  mounted() {
    this.$emit('update-value', this.value);
  },

  methods: {
    closeButtonTheConfigurator() {
      this.$store.commit('setTheConfiguratorDisplay', false);
    },

    handleRangeTouch() {
      const wrapper = document.querySelector('#theConfiguratorContent');

      if (wrapper.scrollTop === 0) wrapper.scroll(0, 1);
      if (Math.ceil(wrapper.scrollTop + wrapper.clientHeight) === wrapper.scrollHeight)
        wrapper.scroll(0, wrapper.scrollTop - 1);
    },

    handlePayClick() {
      this.$emit('update-component', 'CheckoutEndpoint');
    },

    updateTotal() {
      if (this.value.period.key === '3d') {
        this.value.total =
          (this.value.mode.key === 'archived' && this.value.network.key === 'mainnet') ||
          (this.value.chain.key === 'SOL' && this.value.network.key !== 'testnet')
            ? 90
            : 50;
        return;
      }

      if (this.value.mode.key === 'archived' && this.value.network.key === 'mainnet') {
        this.value.total = this.value.period.value * 590;
      } else if (this.value.mode.key === 'archived' && this.value.network.key === 'testnet') {
        this.value.total = this.value.period.value * 380;
      } else if (this.value.mode.key === 'full' && this.value.network.key === 'testnet') {
        this.value.total = this.value.period.value * 180;
      } else if (
        this.value.mode.key === 'full' &&
        this.value.network.key === 'mainnet' &&
        this.value.chain.key === 'SOL'
      ) {
        this.value.total = this.value.period.value * 410;
      } else {
        this.value.total = this.value.period.value * 370;
      }
    },
  },
};
</script>
